<template>
  <div v-loading="loading">
    <CDataTable
      hover
      sorter
      :items="products"
      :fields="FIELDS"
      class="item-table"
    >
      <template #box="{item}">
        <td>
          {{ item.box.name }}
        </td>
      </template>

      <template #status="{item}">
        <td>
          <span :class="`badge badge-${item.status === 1 ? '' : 'danger'}`">
            {{ item.status === 1 ? "" : "鉄砲" }}
          </span>
        </td>
      </template>

      <template #starting_price="{item}">
        <td>
          {{ new Intl.NumberFormat('ja-JP', { style: 'currency', currency: 'JPY' }).format(item.starting_price) }}
        </td>
      </template>

      <template #current_price="{item}">
        <td>
          {{ new Intl.NumberFormat('ja-JP', { style: 'currency', currency: 'JPY' }).format(item.current_price) }}
        </td>
      </template>

      <template #expected_price="{item}">
        <td>
          {{ new Intl.NumberFormat('ja-JP', { style: 'currency', currency: 'JPY' }).format(item.expected_price) }}
        </td>
      </template>

      <template #action="{ item }">
        <td class="white-space-nowrap">
          <CButton size="sm" color="primary" @click="showDetail(item.id)">
            細部
          </CButton>
        </td>
      </template>
    </CDataTable>
  </div>
</template>

<style lang="scss" scoped>
  .item-table {
    /deep/ {
      table {
        border-bottom: 1px solid #d8dbe0;
        margin-bottom: 0;
        thead {
          tr {
            th {
              &.action {
                width: 80px;
              }
            }
          }
        }
      }
    }
  }
</style>

<script>
const EVENT_DETAIL = 'detail'

const FIELDS = [
  { key: 'box', label: '箱番', _classes: 'box' },
  { key: 'id', label: '行', _classes: 'id' },
  { key: 'images', label: '*', _classes: 'images' },
  { key: 'name', label: '品名', _classes: 'name' },
  { key: 'note', label: '備考', _classes: 'note' },
  { key: 'number', label: '入札数', _classes: 'bids' },
  { key: 'starting_price', label: '入札額', _classes: 'startingPrice' },
  { key: 'current_price', label: '落札者', _classes: 'expectedPrice' },
  { key: 'expected_price', label: '落札額', _classes: 'expectedPrice' },
  { key: 'status', label: '', _classes: 'status' },
  { key: 'action', label: '', _classes: 'action', sorter: false }
]

export default {
  props: {
    /**
     * Products list of user login
     */
    products: {
      type: Array,
      default: () => []
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    /**
     * Get FIELDS of header table
     *
     * @return {array} FIELDS of header table
     */
    FIELDS () {
      return FIELDS
    }
  },

  methods: {
    /**
     * Show detail
     *
     * @param {String} id - Item id
     */
    showDetail (id) {
      this.$emit(EVENT_DETAIL, id)
    }
  }
}
</script>
